#include <stdint.h>
#include <avr/io.h>
#include <avr/pgmspace.h>

typedef unsigned char  u8;
typedef unsigned short u16;
typedef char 	       s8;
typedef short 	   	   s16;

/*
------------------------------------------------
'A',		// Alles setzen
'B',		// Alles lschen
------------------------------------------------
'C',0,		// Ebene x EIN
'D',0,		// Ebene x AUS
------------------------------------------------
'E',0,0,	// Line x Muster m EIN
'F',0,0,	// Line x Muster m AUS
------------------------------------------------
'G',0,0,0	// Point a,b,c EIN
'H',0,0,0	// Point a,b,c AUS
------------------------------------------------
'P'			// Pause (100ms) {wa}
'W'			// Wait x (100ms)
------------------------------------------------
'X'			// Ende Muster
'Z'			// neu anfangen
------------------------------------------------
*/

u8 muster1[] PROGMEM ={'G',0,0,0, // Set Point
					   'G',2,2,0, // Set Point
					   'P',	
					   'H',0,0,0, // Clr Point
					   'H',2,2,0, // Clr Point
                       'G',0,0,1, // Set Point
                       'G',2,2,1, // Set Point
					   'P',	
                       'H',0,0,1, // Clr Point
                       'H',2,2,1, // Clr Point
                       'G',0,0,2, // Set Point
                       'G',2,2,2, // Set Point
					   'P',	
                       'H',0,0,2, // Clr Point
                       'H',2,2,2, // Clr Point
                       'G',1,1,2, // Set Point
					   'P',	
                       'H',1,1,2, // Clr Point
                       'G',2,0,2, // Set Point
                       'G',0,2,2, // Set Point
					   'P',	
                       'H',2,0,2, // Clr Point
                       'H',0,0,2, // Clr Point
                       'G',2,0,1, // Set Point
                       'G',0,2,1, // Set Point
					   'P',	
                       'H',2,0,1, // Clr Point
                       'H',0,0,1, // Clr Point
                       'G',2,0,0, // Set Point
                       'G',0,2,0, // Set Point
					   'P',	
                       'H',2,0,0, // Clr Point
                       'H',0,2,0, // Clr Point
                       'G',1,0,0, // Set Point
                       'G',0,1,0, // Set Point
					   'P',	
                       'H',1,0,0, // Clr Point
                       'H',0,1,0, // Clr Point
					   'X'};
					   
u8 muster2[] PROGMEM ={'E',0,5,	  // Set Line
					   'E',2,5,   // Set Line
					   'P',	
					   'E',3,5,   // Set Line
					   'E',5,5,   // Set Line
					   'P',	
					   'E',6,5,   // Set Line
					   'E',8,5,   // Set Line
					   'P',	
					   'C',2,     // Set Ebene
					   'P',	
					   'C',1,     // Set Ebene	
					   'D',2,     // Clr Ebene	
					   'P',	
					   'C',0,     // Set Ebene	
					   'D',1,     // Clr Ebene	
					   'P',	
					   'D',0,     // Clr Ebene	
					   'P',	
					   'X'};
					   
u8 muster3[] PROGMEM ={'G',1,1,0, // Set Point
					   'P',	
                       'G',1,1,1, // Set Point
					   'P',	
                       'G',1,1,2, // Set Point
                       'H',1,1,0, // Clr Point
					   'P',	
					   'E',6,5,   // Set Line
					   'E',8,5,   // Set Line
                       'H',1,1,1, // Clr Point
					   'P',	
					   'E',3,5,   // Set Line
					   'E',5,5,   // Set Line
					   'F',6,5,	  // Clr Line
					   'F',8,5,	  // Clr Line
                       'H',1,1,2, // Clr Point
					   'P',	
					   'E',2,5,   // Set Line
					   'E',0,5,   // Set Line
					   'F',3,5,	  // Clr Line
					   'F',5,5,	  // Clr Line
					   'P',	
					   'F',2,5,   // Clr Line
					   'F',0,5,   // Clr Line
					   'P',	
					   'X'};
					   
u8 muster4[] PROGMEM ={'C',4,	  // Set Ebene
					   'P',	
					   'D',4,	  // Clr Ebene
					   'E',2,7,	  // Set Line
					   'E',4,7,   // Set Line
					   'E',6,7,   // Set Line
					   'P',	
					   'F',2,7,	  // Clr Line
					   'F',4,7,	  // Clr Line
					   'F',6,7,	  // Clr Line
					   'C',1,	  // Set Ebene
					   'P',	
					   'D',1,	  // Clr Ebene
					   'E',0,7,	  // Set Line
					   'E',4,7,   // Set Line
					   'E',8,7,   // Set Line
					   'P',	
					   'F',0,7,	  // Clr Line
					   'F',4,7,	  // Clr Line
					   'F',8,7,	  // Clr Line
					   'X'};
					   
u8 muster5[] PROGMEM ={'A',		  // Alles AN
					   'W',5,	  // Wait
					   'B',		  // Alles AUS
					   'W',5,	  // Wait
					   'X'};
					   
u8 muster6[] PROGMEM ={'G',0,0,1, // Set Point
					   'G',1,0,1, // Set Point
					   'G',2,0,1, // Set Point
					   'P',	
					   'H',0,0,1, // Clr Point
					   'H',1,0,1, // Clr Point
					   'H',2,0,1, // Clr Point
					   'G',0,1,0, // Set Point
					   'G',1,1,1, // Set Point
					   'G',2,1,2, // Set Point
					   'P',	
					   'H',0,1,0, // Clr Point
					   'H',1,1,1, // Clr Point
					   'H',2,1,2, // Clr Point
					   'G',1,2,0, // Set Point
					   'G',1,2,1, // Set Point
					   'G',1,2,2, // Set Point
					   'P',
					   'H',1,2,0, // Clr Point
					   'H',1,2,1, // Clr Point
					   'H',1,2,2, // Clr Point
					   'G',0,1,2, // Set Point
					   'G',1,1,1, // Set Point
					   'G',2,1,0, // Set Point
					   'P',
					   'H',0,1,2, // Clr Point
					   'H',1,1,1, // Clr Point
					   'H',2,1,0, // Clr Point
                       'X'};

u8 muster7[] PROGMEM ={'C',3,	  // Set Ebene
					   'P',
					   'D',3,	  // Clr Ebene
					   'C',4,	  // Set Ebene
					   'P',
					   'D',4,	  // Clr Ebene
					   'C',5,	  // Set Ebene
					   'P',
					   'D',5,	  // Clr Ebene
					   'X'};

u8 musterX[] PROGMEM = {'Z','Z','Z','Z'};	

u8* musterTab[] PROGMEM = { muster1,
							muster1,
							muster1,

                            muster2,
                            muster2,
                            muster2,

							muster3,
							muster3,
							muster3,

							muster4,
							muster4,
							muster4,

							muster5,
							muster5,
							muster5,

							muster6,
							muster6,
							muster6,

							muster7,
							muster7,
							muster7,

							muster6,
							muster6,
							muster6,
							
							musterX };

#define F_CPU 8000000UL
